///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBAUTHTokenScopeError;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `TokenScopeError` struct.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBAUTHTokenScopeError : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The required scope to access the route.
@property (nonatomic, readonly, copy) NSString *requiredScope;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param requiredScope The required scope to access the route.
///
/// @return An initialized instance.
///
- (instancetype)initWithRequiredScope:(NSString *)requiredScope;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `TokenScopeError` struct.
///
@interface DBAUTHTokenScopeErrorSerializer : NSObject

///
/// Serializes `DBAUTHTokenScopeError` instances.
///
/// @param instance An instance of the `DBAUTHTokenScopeError` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBAUTHTokenScopeError` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBAUTHTokenScopeError *)instance;

///
/// Deserializes `DBAUTHTokenScopeError` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBAUTHTokenScopeError` API object.
///
/// @return An instantiation of the `DBAUTHTokenScopeError` object.
///
+ (DBAUTHTokenScopeError *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
