///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBFILESAddTagArg;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `AddTagArg` struct.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBFILESAddTagArg : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// Path to the item to be tagged.
@property (nonatomic, readonly, copy) NSString *path;

/// The value of the tag to add.
@property (nonatomic, readonly, copy) NSString *tagText;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param path Path to the item to be tagged.
/// @param tagText The value of the tag to add.
///
/// @return An initialized instance.
///
- (instancetype)initWithPath:(NSString *)path tagText:(NSString *)tagText;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `AddTagArg` struct.
///
@interface DBFILESAddTagArgSerializer : NSObject

///
/// Serializes `DBFILESAddTagArg` instances.
///
/// @param instance An instance of the `DBFILESAddTagArg` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBFILESAddTagArg` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBFILESAddTagArg *)instance;

///
/// Deserializes `DBFILESAddTagArg` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBFILESAddTagArg` API object.
///
/// @return An instantiation of the `DBFILESAddTagArg` object.
///
+ (DBFILESAddTagArg *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
