///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBFILESAddTagError;
@class DBFILESLookupError;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `AddTagError` union.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBFILESAddTagError : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The `DBFILESAddTagErrorTag` enum type represents the possible tag states
/// with which the `DBFILESAddTagError` union can exist.
typedef NS_CLOSED_ENUM(NSInteger, DBFILESAddTagErrorTag){
    /// (no description).
    DBFILESAddTagErrorPath,

    /// (no description).
    DBFILESAddTagErrorOther,

    /// The item already has the maximum supported number of tags.
    DBFILESAddTagErrorTooManyTags,

};

/// Represents the union's current tag state.
@property (nonatomic, readonly) DBFILESAddTagErrorTag tag;

/// (no description). @note Ensure the `isPath` method returns true before
/// accessing, otherwise a runtime exception will be raised.
@property (nonatomic, readonly) DBFILESLookupError *path;

#pragma mark - Constructors

///
/// Initializes union class with tag state of "path".
///
/// @param path (no description).
///
/// @return An initialized instance.
///
- (instancetype)initWithPath:(DBFILESLookupError *)path;

///
/// Initializes union class with tag state of "other".
///
/// @return An initialized instance.
///
- (instancetype)initWithOther;

///
/// Initializes union class with tag state of "too_many_tags".
///
/// Description of the "too_many_tags" tag state: The item already has the
/// maximum supported number of tags.
///
/// @return An initialized instance.
///
- (instancetype)initWithTooManyTags;

- (instancetype)init NS_UNAVAILABLE;

#pragma mark - Tag state methods

///
/// Retrieves whether the union's current tag state has value "path".
///
/// @note Call this method and ensure it returns true before accessing the
/// `path` property, otherwise a runtime exception will be thrown.
///
/// @return Whether the union's current tag state has value "path".
///
- (BOOL)isPath;

///
/// Retrieves whether the union's current tag state has value "other".
///
/// @return Whether the union's current tag state has value "other".
///
- (BOOL)isOther;

///
/// Retrieves whether the union's current tag state has value "too_many_tags".
///
/// @return Whether the union's current tag state has value "too_many_tags".
///
- (BOOL)isTooManyTags;

///
/// Retrieves string value of union's current tag state.
///
/// @return A human-readable string representing the union's current tag state.
///
- (NSString *)tagName;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DBFILESAddTagError` union.
///
@interface DBFILESAddTagErrorSerializer : NSObject

///
/// Serializes `DBFILESAddTagError` instances.
///
/// @param instance An instance of the `DBFILESAddTagError` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBFILESAddTagError` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBFILESAddTagError *)instance;

///
/// Deserializes `DBFILESAddTagError` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBFILESAddTagError` API object.
///
/// @return An instantiation of the `DBFILESAddTagError` object.
///
+ (DBFILESAddTagError *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
