///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBFILESLookupError;
@class DBFILESRemoveTagError;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `RemoveTagError` union.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBFILESRemoveTagError : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The `DBFILESRemoveTagErrorTag` enum type represents the possible tag states
/// with which the `DBFILESRemoveTagError` union can exist.
typedef NS_CLOSED_ENUM(NSInteger, DBFILESRemoveTagErrorTag){
    /// (no description).
    DBFILESRemoveTagErrorPath,

    /// (no description).
    DBFILESRemoveTagErrorOther,

    /// That tag doesn't exist at this path.
    DBFILESRemoveTagErrorTagNotPresent,

};

/// Represents the union's current tag state.
@property (nonatomic, readonly) DBFILESRemoveTagErrorTag tag;

/// (no description). @note Ensure the `isPath` method returns true before
/// accessing, otherwise a runtime exception will be raised.
@property (nonatomic, readonly) DBFILESLookupError *path;

#pragma mark - Constructors

///
/// Initializes union class with tag state of "path".
///
/// @param path (no description).
///
/// @return An initialized instance.
///
- (instancetype)initWithPath:(DBFILESLookupError *)path;

///
/// Initializes union class with tag state of "other".
///
/// @return An initialized instance.
///
- (instancetype)initWithOther;

///
/// Initializes union class with tag state of "tag_not_present".
///
/// Description of the "tag_not_present" tag state: That tag doesn't exist at
/// this path.
///
/// @return An initialized instance.
///
- (instancetype)initWithTagNotPresent;

- (instancetype)init NS_UNAVAILABLE;

#pragma mark - Tag state methods

///
/// Retrieves whether the union's current tag state has value "path".
///
/// @note Call this method and ensure it returns true before accessing the
/// `path` property, otherwise a runtime exception will be thrown.
///
/// @return Whether the union's current tag state has value "path".
///
- (BOOL)isPath;

///
/// Retrieves whether the union's current tag state has value "other".
///
/// @return Whether the union's current tag state has value "other".
///
- (BOOL)isOther;

///
/// Retrieves whether the union's current tag state has value "tag_not_present".
///
/// @return Whether the union's current tag state has value "tag_not_present".
///
- (BOOL)isTagNotPresent;

///
/// Retrieves string value of union's current tag state.
///
/// @return A human-readable string representing the union's current tag state.
///
- (NSString *)tagName;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DBFILESRemoveTagError` union.
///
@interface DBFILESRemoveTagErrorSerializer : NSObject

///
/// Serializes `DBFILESRemoveTagError` instances.
///
/// @param instance An instance of the `DBFILESRemoveTagError` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBFILESRemoveTagError` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBFILESRemoveTagError *)instance;

///
/// Deserializes `DBFILESRemoveTagError` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBFILESRemoveTagError` API object.
///
/// @return An instantiation of the `DBFILESRemoveTagError` object.
///
+ (DBFILESRemoveTagError *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
