///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMMembersGetInfoItemBase;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `MembersGetInfoItemBase` union.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMMembersGetInfoItemBase : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The `DBTEAMMembersGetInfoItemBaseTag` enum type represents the possible tag
/// states with which the `DBTEAMMembersGetInfoItemBase` union can exist.
typedef NS_CLOSED_ENUM(NSInteger, DBTEAMMembersGetInfoItemBaseTag){
    /// An ID that was provided as a parameter to `membersGetInfo` or
    /// `membersGetInfo`, and did not match a corresponding user. This might be
    /// a team_member_id, an email, or an external ID, depending on how the
    /// method was called.
    DBTEAMMembersGetInfoItemBaseIdNotFound,

};

/// Represents the union's current tag state.
@property (nonatomic, readonly) DBTEAMMembersGetInfoItemBaseTag tag;

/// An ID that was provided as a parameter to `membersGetInfo` or
/// `membersGetInfo`, and did not match a corresponding user. This might be a
/// team_member_id, an email, or an external ID, depending on how the method was
/// called. @note Ensure the `isIdNotFound` method returns true before
/// accessing, otherwise a runtime exception will be raised.
@property (nonatomic, readonly, copy) NSString *idNotFound;

#pragma mark - Constructors

///
/// Initializes union class with tag state of "id_not_found".
///
/// Description of the "id_not_found" tag state: An ID that was provided as a
/// parameter to `membersGetInfo` or `membersGetInfo`, and did not match a
/// corresponding user. This might be a team_member_id, an email, or an external
/// ID, depending on how the method was called.
///
/// @param idNotFound An ID that was provided as a parameter to `membersGetInfo`
/// or `membersGetInfo`, and did not match a corresponding user. This might be a
/// team_member_id, an email, or an external ID, depending on how the method was
/// called.
///
/// @return An initialized instance.
///
- (instancetype)initWithIdNotFound:(NSString *)idNotFound;

- (instancetype)init NS_UNAVAILABLE;

#pragma mark - Tag state methods

///
/// Retrieves whether the union's current tag state has value "id_not_found".
///
/// @note Call this method and ensure it returns true before accessing the
/// `idNotFound` property, otherwise a runtime exception will be thrown.
///
/// @return Whether the union's current tag state has value "id_not_found".
///
- (BOOL)isIdNotFound;

///
/// Retrieves string value of union's current tag state.
///
/// @return A human-readable string representing the union's current tag state.
///
- (NSString *)tagName;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DBTEAMMembersGetInfoItemBase` union.
///
@interface DBTEAMMembersGetInfoItemBaseSerializer : NSObject

///
/// Serializes `DBTEAMMembersGetInfoItemBase` instances.
///
/// @param instance An instance of the `DBTEAMMembersGetInfoItemBase` API
/// object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMMembersGetInfoItemBase` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMMembersGetInfoItemBase *)instance;

///
/// Deserializes `DBTEAMMembersGetInfoItemBase` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMMembersGetInfoItemBase` API object.
///
/// @return An instantiation of the `DBTEAMMembersGetInfoItemBase` object.
///
+ (DBTEAMMembersGetInfoItemBase *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
