///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMMembersSetPermissions2Arg;
@class DBTEAMUserSelectorArg;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `MembersSetPermissions2Arg` struct.
///
/// Exactly one of team_member_id, email, or external_id must be provided to
/// identify the user account.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMMembersSetPermissions2Arg : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// Identity of user whose role will be set.
@property (nonatomic, readonly) DBTEAMUserSelectorArg *user;

/// The new roles for the member. Send empty list to make user member only. For
/// now, only up to one role is allowed.
@property (nonatomic, readonly, nullable) NSArray<NSString *> *dNewRoles;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param user Identity of user whose role will be set.
/// @param dNewRoles The new roles for the member. Send empty list to make user
/// member only. For now, only up to one role is allowed.
///
/// @return An initialized instance.
///
- (instancetype)initWithUser:(DBTEAMUserSelectorArg *)user dNewRoles:(nullable NSArray<NSString *> *)dNewRoles;

///
/// Convenience constructor (exposes only non-nullable instance variables with
/// no default value).
///
/// @param user Identity of user whose role will be set.
///
/// @return An initialized instance.
///
- (instancetype)initWithUser:(DBTEAMUserSelectorArg *)user;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `MembersSetPermissions2Arg` struct.
///
@interface DBTEAMMembersSetPermissions2ArgSerializer : NSObject

///
/// Serializes `DBTEAMMembersSetPermissions2Arg` instances.
///
/// @param instance An instance of the `DBTEAMMembersSetPermissions2Arg` API
/// object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMMembersSetPermissions2Arg` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMMembersSetPermissions2Arg *)instance;

///
/// Deserializes `DBTEAMMembersSetPermissions2Arg` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMMembersSetPermissions2Arg` API object.
///
/// @return An instantiation of the `DBTEAMMembersSetPermissions2Arg` object.
///
+ (DBTEAMMembersSetPermissions2Arg *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
