///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGDefaultLinkExpirationDaysPolicy;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `DefaultLinkExpirationDaysPolicy` union.
///
/// Policy for the default number of days until an externally shared link
/// expires
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGDefaultLinkExpirationDaysPolicy : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The `DBTEAMLOGDefaultLinkExpirationDaysPolicyTag` enum type represents the
/// possible tag states with which the
/// `DBTEAMLOGDefaultLinkExpirationDaysPolicy` union can exist.
typedef NS_CLOSED_ENUM(NSInteger, DBTEAMLOGDefaultLinkExpirationDaysPolicyTag){
    /// (no description).
    DBTEAMLOGDefaultLinkExpirationDaysPolicyDay1,

    /// (no description).
    DBTEAMLOGDefaultLinkExpirationDaysPolicyDay180,

    /// (no description).
    DBTEAMLOGDefaultLinkExpirationDaysPolicyDay3,

    /// (no description).
    DBTEAMLOGDefaultLinkExpirationDaysPolicyDay30,

    /// (no description).
    DBTEAMLOGDefaultLinkExpirationDaysPolicyDay7,

    /// (no description).
    DBTEAMLOGDefaultLinkExpirationDaysPolicyDay90,

    /// (no description).
    DBTEAMLOGDefaultLinkExpirationDaysPolicyNone,

    /// (no description).
    DBTEAMLOGDefaultLinkExpirationDaysPolicyYear1,

    /// (no description).
    DBTEAMLOGDefaultLinkExpirationDaysPolicyOther,

};

/// Represents the union's current tag state.
@property (nonatomic, readonly) DBTEAMLOGDefaultLinkExpirationDaysPolicyTag tag;

#pragma mark - Constructors

///
/// Initializes union class with tag state of "day_1".
///
/// @return An initialized instance.
///
- (instancetype)initWithDay1;

///
/// Initializes union class with tag state of "day_180".
///
/// @return An initialized instance.
///
- (instancetype)initWithDay180;

///
/// Initializes union class with tag state of "day_3".
///
/// @return An initialized instance.
///
- (instancetype)initWithDay3;

///
/// Initializes union class with tag state of "day_30".
///
/// @return An initialized instance.
///
- (instancetype)initWithDay30;

///
/// Initializes union class with tag state of "day_7".
///
/// @return An initialized instance.
///
- (instancetype)initWithDay7;

///
/// Initializes union class with tag state of "day_90".
///
/// @return An initialized instance.
///
- (instancetype)initWithDay90;

///
/// Initializes union class with tag state of "none".
///
/// @return An initialized instance.
///
- (instancetype)initWithNone;

///
/// Initializes union class with tag state of "year_1".
///
/// @return An initialized instance.
///
- (instancetype)initWithYear1;

///
/// Initializes union class with tag state of "other".
///
/// @return An initialized instance.
///
- (instancetype)initWithOther;

- (instancetype)init NS_UNAVAILABLE;

#pragma mark - Tag state methods

///
/// Retrieves whether the union's current tag state has value "day_1".
///
/// @return Whether the union's current tag state has value "day_1".
///
- (BOOL)isDay1;

///
/// Retrieves whether the union's current tag state has value "day_180".
///
/// @return Whether the union's current tag state has value "day_180".
///
- (BOOL)isDay180;

///
/// Retrieves whether the union's current tag state has value "day_3".
///
/// @return Whether the union's current tag state has value "day_3".
///
- (BOOL)isDay3;

///
/// Retrieves whether the union's current tag state has value "day_30".
///
/// @return Whether the union's current tag state has value "day_30".
///
- (BOOL)isDay30;

///
/// Retrieves whether the union's current tag state has value "day_7".
///
/// @return Whether the union's current tag state has value "day_7".
///
- (BOOL)isDay7;

///
/// Retrieves whether the union's current tag state has value "day_90".
///
/// @return Whether the union's current tag state has value "day_90".
///
- (BOOL)isDay90;

///
/// Retrieves whether the union's current tag state has value "none".
///
/// @return Whether the union's current tag state has value "none".
///
- (BOOL)isNone;

///
/// Retrieves whether the union's current tag state has value "year_1".
///
/// @return Whether the union's current tag state has value "year_1".
///
- (BOOL)isYear1;

///
/// Retrieves whether the union's current tag state has value "other".
///
/// @return Whether the union's current tag state has value "other".
///
- (BOOL)isOther;

///
/// Retrieves string value of union's current tag state.
///
/// @return A human-readable string representing the union's current tag state.
///
- (NSString *)tagName;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DBTEAMLOGDefaultLinkExpirationDaysPolicy`
/// union.
///
@interface DBTEAMLOGDefaultLinkExpirationDaysPolicySerializer : NSObject

///
/// Serializes `DBTEAMLOGDefaultLinkExpirationDaysPolicy` instances.
///
/// @param instance An instance of the
/// `DBTEAMLOGDefaultLinkExpirationDaysPolicy` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGDefaultLinkExpirationDaysPolicy` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGDefaultLinkExpirationDaysPolicy *)instance;

///
/// Deserializes `DBTEAMLOGDefaultLinkExpirationDaysPolicy` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGDefaultLinkExpirationDaysPolicy` API object.
///
/// @return An instantiation of the `DBTEAMLOGDefaultLinkExpirationDaysPolicy`
/// object.
///
+ (DBTEAMLOGDefaultLinkExpirationDaysPolicy *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
