///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGEmailIngestReceiveFileDetails;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `EmailIngestReceiveFileDetails` struct.
///
/// Received files via Email to Dropbox.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGEmailIngestReceiveFileDetails : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// Inbox name.
@property (nonatomic, readonly, copy) NSString *inboxName;

/// Submitted file names.
@property (nonatomic, readonly) NSArray<NSString *> *attachmentNames;

/// Subject of the email.
@property (nonatomic, readonly, copy, nullable) NSString *subject;

/// The name as provided by the submitter.
@property (nonatomic, readonly, copy, nullable) NSString *fromName;

/// The email as provided by the submitter.
@property (nonatomic, readonly, copy, nullable) NSString *fromEmail;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param inboxName Inbox name.
/// @param attachmentNames Submitted file names.
/// @param subject Subject of the email.
/// @param fromName The name as provided by the submitter.
/// @param fromEmail The email as provided by the submitter.
///
/// @return An initialized instance.
///
- (instancetype)initWithInboxName:(NSString *)inboxName
                  attachmentNames:(NSArray<NSString *> *)attachmentNames
                          subject:(nullable NSString *)subject
                         fromName:(nullable NSString *)fromName
                        fromEmail:(nullable NSString *)fromEmail;

///
/// Convenience constructor (exposes only non-nullable instance variables with
/// no default value).
///
/// @param inboxName Inbox name.
/// @param attachmentNames Submitted file names.
///
/// @return An initialized instance.
///
- (instancetype)initWithInboxName:(NSString *)inboxName attachmentNames:(NSArray<NSString *> *)attachmentNames;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `EmailIngestReceiveFileDetails` struct.
///
@interface DBTEAMLOGEmailIngestReceiveFileDetailsSerializer : NSObject

///
/// Serializes `DBTEAMLOGEmailIngestReceiveFileDetails` instances.
///
/// @param instance An instance of the `DBTEAMLOGEmailIngestReceiveFileDetails`
/// API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGEmailIngestReceiveFileDetails` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGEmailIngestReceiveFileDetails *)instance;

///
/// Deserializes `DBTEAMLOGEmailIngestReceiveFileDetails` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGEmailIngestReceiveFileDetails` API object.
///
/// @return An instantiation of the `DBTEAMLOGEmailIngestReceiveFileDetails`
/// object.
///
+ (DBTEAMLOGEmailIngestReceiveFileDetails *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
