///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGFileResolveCommentDetails;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `FileResolveCommentDetails` struct.
///
/// Resolved file comment.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGFileResolveCommentDetails : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// Comment text.
@property (nonatomic, readonly, copy, nullable) NSString *commentText;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param commentText Comment text.
///
/// @return An initialized instance.
///
- (instancetype)initWithCommentText:(nullable NSString *)commentText;

///
/// Convenience constructor (exposes only non-nullable instance variables with
/// no default value).
///
///
/// @return An initialized instance.
///
- (instancetype)initDefault;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `FileResolveCommentDetails` struct.
///
@interface DBTEAMLOGFileResolveCommentDetailsSerializer : NSObject

///
/// Serializes `DBTEAMLOGFileResolveCommentDetails` instances.
///
/// @param instance An instance of the `DBTEAMLOGFileResolveCommentDetails` API
/// object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGFileResolveCommentDetails` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGFileResolveCommentDetails *)instance;

///
/// Deserializes `DBTEAMLOGFileResolveCommentDetails` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGFileResolveCommentDetails` API object.
///
/// @return An instantiation of the `DBTEAMLOGFileResolveCommentDetails` object.
///
+ (DBTEAMLOGFileResolveCommentDetails *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
